package 
{
	import flash.geom.Point;
	/**
	 * ...
	 * @author Daz
	 */
	public class Funcs 
	{
		
		//calculate the distance between A and B
		public static function distanceTo(a:Point, b:Point):Number {
			var distance:Number = Math.sqrt(((a.x - b.x) * (a.x - b.x)) + ((a.y - b.y) * (a.y - b.y)));
			if (distance < 0) { distance = distance * -1; }
			return distance;
		}
		
		//calculate the angle between A and B, returned as 360 degrees
		public static function angleTo(a:Point, b:Point):Number {
			var dx:Number = a.x - b.x;
			var dy:Number = a.y - b.y;
			var radians:Number = Math.atan2(dy,dx);
			var degrees:Number = radians * (180/Math.PI);
			return degrees+90;
		}
		
		//calculate the rate of change of x/y when moving to a point
		public static function velocityTo(a:Point, b:Point):Point {
			var distance:Number = Math.sqrt(((a.x - b.x) * (a.x - b.x)) + ((a.y - b.y) * (a.y - b.y)));
			var dx:Number = (a.x - b.x)  / distance;
			var dy:Number = (a.y - b.y)  / distance;
			return new Point(dx, dy);
		}
		
		//calculate whether to rotate left or right to face a point
		/*
		public static function rotateTo(a:Point, b:Point):Number {
			var currentFacing:Number = b.rotation;
			var requiredFacing:Number = angleTo(a, b);
			var distanceClockwise:Number = currentFacing - requiredFacing;
			if (distanceClockwise < 0) { distanceClockwise += 360; }
			var distanceWiddershins:Number= requiredFacing - currentFacing;
			if (distanceWiddershins < 0) { distanceWiddershins += 360; }
			if (distanceClockwise >= distanceWiddershins) { return -1; }
			return 1;
		}*/
		
		//rotate the velocity of an object. Props to FaustoFonseca for this.
		public static function rotatedVelocity(rotation:Number, speed:Number):Point {
			var angle:Number = (rotation + 90) * (Math.PI / 180);
			var dx:Number = Math.cos(angle)*speed;
			var dy:Number = Math.sin(angle)*speed;
			var V:Point = new Point(dx, dy);
			return V;
		}
		
		public static function deepCopy(vector:Vector.<int>):Array {
			var array:Array = new Array();
			for (var n:int = 0; n < vector.length; n++) {
				array.push(vector[n]);
			}
			return array;
		}
		
		public static function insidePolygon(pointList:Array, p:Point):Boolean{
			var counter:int = 0;
			var i:int;
			var xinters:Number;
			var p1:Point;
			var p2:Point;
			var n:int = pointList.length;
		 
			p1 = pointList[0];
			for (i = 1; i <= n; i++)
			{
				p2 = pointList[i % n];
				if (p.y > Math.min(p1.y, p2.y))
				{
					if (p.y <= Math.max(p1.y, p2.y))
					{
						if (p.x <= Math.max(p1.x, p2.x))
						{
							if (p1.y != p2.y) {
								xinters = (p.y - p1.y) * (p2.x - p1.x) / (p2.y - p1.y) + p1.x;
								if (p1.x == p2.x || p.x <= xinters)
									counter++;
							}
						}
					}
				}
				p1 = p2;
			}
			if (counter % 2 == 0)
			{
				return(false);
			}
			else
			{
				return(true);
			}
		}
		
	}

}